#include "../../../lib/config.mi"

#define CUSTOM_PAGE_NOTIFIER "{7C141D9D-E200-49ED-9132-5140AEB0BBEB}"
#define HIDDEN_PAGE "{A799765D-D460-40CB-8C43-7A09BFE69416}"

Function initAttribs();
Global ConfigAttribute attrib_desktopalpha;
Global ConfigAttribute attrib_ConfigNotifierPosition;
Global ConfigAttribute attrib_ConfigNotifierAnimation;

Global ConfigAttribute attrib_notifierAlways;
Global ConfigAttribute attrib_notifierMinimized;
Global ConfigAttribute attrib_notifierNever;
Global ConfigAttribute attrib_notifierDisableFullscreen;
Global ConfigAttribute attrib_notifierPositionLeft;
Global ConfigAttribute attrib_notifierPositionRight;
Global ConfigAttribute attrib_notifierPositionTop;
Global ConfigAttribute attrib_notifierPositionBottom;
Global ConfigAttribute attrib_notifierNoAnimation;
Global ConfigAttribute attrib_notifierFade;
Global ConfigAttribute attrib_notifierRollUpDown;
Global ConfigAttribute attrib_notifierSlideVertical;
Global ConfigAttribute attrib_notifierSlideHorizontal;
Global ConfigAttribute attrib_notifierHoldtime;
Global ConfigAttribute attrib_notifierSlideTime;
Global ConfigAttribute attrib_notifierShowCoverArt;
Global ConfigAttribute attrib_notifierSmoothCovertArt;
Global ConfigAttribute attrib_notifierAOT;

Global ConfigAttribute attrib_system_enableDesktopAlpha;

initAttribs() {
	ConfigItem custom_page_notifier = Config.newItem("Notifications", CUSTOM_PAGE_NOTIFIER);		
	ConfigItem hidden_page = Config.newItem(System.getSkinName() + " Hidden", HIDDEN_PAGE);
	
	attrib_ConfigNotifierPosition = hidden_page.newAttribute("Config Notifier Position", "1");	
	attrib_ConfigNotifierAnimation = hidden_page.newAttribute("Config Notifier Animation", "0");	

	ConfigAttribute notifiersubmenu = custom_page_notifier.newAttribute("Notifications", "");	
	
	notifiersubmenu.setData(CUSTOM_PAGE_NOTIFIER);	
	attrib_notifierAlways = custom_page_notifier.newAttribute("Show Always", "1");
	attrib_notifierMinimized = custom_page_notifier.newAttribute("Show Only When Minimized", "0");
	attrib_notifierNever = custom_page_notifier.newAttribute("Never Show", "0");
	ConfigAttribute sep1 = custom_page_notifier.newAttribute("sep1", ""); sep1.setData("-");
	attrib_notifierDisableFullscreen = custom_page_notifier.newAttribute("Disable In Fullscreen", "1");
	ConfigAttribute sep2 = custom_page_notifier.newAttribute("sep2", ""); sep2.setData("-");
	attrib_notifierPositionTop = custom_page_notifier.newAttribute("Appears On Top", "0");
	attrib_notifierPositionBottom = custom_page_notifier.newAttribute("Appears On Bottom", "1");
	ConfigAttribute sep3 = custom_page_notifier.newAttribute("sep3", ""); sep3.setData("-");
	attrib_notifierPositionLeft = custom_page_notifier.newAttribute("Appears On Left", "0");
	attrib_notifierPositionRight = custom_page_notifier.newAttribute("Appears On Right", "1");
	ConfigAttribute sep4 = custom_page_notifier.newAttribute("sep4", ""); sep4.setData("-");
	attrib_notifierNoAnimation = custom_page_notifier.newAttribute("No Animation", "0");
	attrib_notifierFade = custom_page_notifier.newAttribute("Fade In/Out", "1");
	attrib_notifierRollUpDown = custom_page_notifier.newAttribute("Roll Up/Down", "0");
	attrib_notifierSlideVertical = custom_page_notifier.newAttribute("Slide Vertically", "0");
	attrib_notifierSlideHorizontal = custom_page_notifier.newAttribute("Slide Horizontally", "0");
	attrib_notifierHoldtime = hidden_page.newAttribute("Notifications Display Time", "5000");
	attrib_notifierSlideTime = hidden_page.newAttribute("Notifications Slide Time", "2");	
	ConfigAttribute sep5 = custom_page_notifier.newAttribute("sep5", ""); sep5.setData("-");
	attrib_notifierShowCoverArt = custom_page_notifier.newAttribute("Show Cover Art", "1");	
	attrib_notifierSmoothCovertArt = custom_page_notifier.newAttribute("Smooth Cover Art", "1");		
	ConfigAttribute sep8 = custom_page_notifier.newAttribute("sep8", ""); sep8.setData("-");
	attrib_notifierAOT = custom_page_notifier.newAttribute("Notifier Always on Top", "1");
	
	
	ConfigItem item;
	item = Config.getItem("Skins and UI Tweaks");
	if (item != NULL) attrib_desktopalpha = item.getAttribute("Enable Desktop Alpha");
	if(StringToInteger(attrib_desktopalpha.getData()) != 1){attrib_desktopalpha.setData("1");}
}

#ifdef MAIN_ATTRIBS_MGR
	#define NOOFF if (getData() == "0") { setData("1"); return; }
	
	Global Boolean boolMyChange;
	
	attrib_notifierAlways.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierNever.setData("0");
		attrib_notifierMinimized.setData("0");
		boolMyChange = false;
	}
	attrib_notifierNever.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierAlways.setData("0");
		attrib_notifierMinimized.setData("0");
		boolMyChange = false;
	}
	attrib_notifierMinimized.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierNever.setData("0");
		attrib_notifierAlways.setData("0");
		boolMyChange = false;
	}
	attrib_notifierPositionTop.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierPositionBottom.setData("0");
		boolMyChange = false;
	}
	attrib_notifierPositionBottom.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierPositionTop.setData("0");
		boolMyChange = false;
	}
	attrib_notifierPositionLeft.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierPositionRight.setData("0");
		boolMyChange = false;
	}
	attrib_notifierPositionRight.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierPositionLeft.setData("0");
		boolMyChange = false;
	}
	attrib_notifierNoAnimation.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierFade.setData("0");
		attrib_notifierRollUpDown.setData("0");
		attrib_notifierSlideHorizontal.setData("0");
		attrib_notifierSlideVertical.setData("0");
		boolMyChange = false;
	}
	attrib_notifierFade.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierNoAnimation.setData("0");
		attrib_notifierRollUpDown.setData("0");
		attrib_notifierSlideVertical.setData("0");
		attrib_notifierSlideHorizontal.setData("0");
		boolMyChange = false;
	}
	attrib_notifierSlideVertical.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierNoAnimation.setData("0");
		attrib_notifierRollUpDown.setData("0");
		attrib_notifierFade.setData("0");
		attrib_notifierSlideHorizontal.setData("0");
		boolMyChange = false;
	}
	attrib_notifierSlideHorizontal.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierNoAnimation.setData("0");
		attrib_notifierRollUpDown.setData("0");
		attrib_notifierFade.setData("0");
		attrib_notifierSlideVertical.setData("0");
		boolMyChange = false;
	}
	attrib_notifierRollUpDown.onDataChanged() {
		if (boolMyChange) return;
		NOOFF
		boolMyChange = true;
		attrib_notifierNoAnimation.setData("0");
		attrib_notifierFade.setData("0");
		attrib_notifierSlideHorizontal.setData("0");
		attrib_notifierSlideVertical.setData("0");
		boolMyChange = false;
	}	
#endif