#include "../../../lib/std.mi"
#include "attribs.m"
#include "utility.m"

Function reset();
Function createNotifier();
Function showNotifier(Int w);
Function onNext();
Function Int fillNextTrackInfo(String corneroverride);
Function checkPref(int bypassfs);

Global Container containerNotifier;
Global Layout layoutNotifier;
Global Group groupNotifierText, groupNotifierCover, coverandbutton;
Global GuiObject NotifierBG, coverBorder;
Global Layer layerNotifierCoverImage;
Global Slider sliderHoldtime, sliderSlidetime;
Global Timer timerNotifier, timerShow;
Global Text textHoldtime, textHoldtimeSec, textSlidetime;
Global String strLastAutoTitle, strPosition;
Global Int intScreenMargin, NotifierTop, NotifierWidth, intNotifierHoldtime;

System.onScriptLoaded() {
	initAttribs();
	intScreenMargin = 5;
	sliderHoldtime = System.getContainer("notifierConfig").getLayout("normal").findObject("sliderholdtime");
	sliderSlidetime = System.getContainer("notifierConfig").getLayout("normal").findObject("sliderslidetime");
	textHoldtime = System.getContainer("notifierConfig").getLayout("normal").findObject("holdtime.display");
	textHoldtimeSec = System.getContainer("notifierConfig").getLayout("normal").findObject("holdtime.sec");
	textSlidetime = System.getContainer("notifierConfig").getLayout("normal").findObject("slidetime.display");
	timerNotifier = new Timer;
	timerShow = new Timer; if (attrib_notifierAlways.getData() == "1") timerShow.setDelay(100); timerShow.start(); 	
	NotifierTop = getPrivateInt(getSkinName(), "NotifierTop", NotifierTop);
	attrib_notifierSlidetime.setData(attrib_notifierSlidetime.getData());	
	attrib_notifierHoldtime.setData(attrib_notifierHoldtime.getData());	
	intNotifierHoldtime = System.StringtoInteger(attrib_notifierHoldtime.getData());
	if (System.stringToInteger(attrib_notifierHoldtime.getData()) >= 21000) {
		textHoldtime.setAlpha(0);
		textHoldtimeSec.setText("Forever");
	} else {
		textHoldtime.setAlpha(255);
		textHoldtime.setText(System.integerToString(intNotifierHoldtime / 1000));
		textHoldtimeSec.setText("Sec");
	}
}
System.onScriptUnloading() {
	SetPrivateInt(getSkinName(), "NotifierTop", NotifierTop);
	delete timerNotifier;
	delete timerNotifier; 	
}
System.onShowNotification() {
	if (checkPref(1)) return;
	createNotifier();
	String str;
	if (getStatus() == STATUS_PLAYING) str = "Playing";
	if (getStatus() == STATUS_PAUSED) str = "Paused";
	if (getStatus() == STATUS_STOPPED) str = "Stopped";
	showNotifier(fillNextTrackInfo(str));
	complete; // prevents other scripts from getting the message
	return 1; // tells anybody else that might watch the returned value that, yes, we implemented that
}
System.onTitleChange(String newtitle) {
	if (strLastAutoTitle == newtitle) return;
	if (StrLeft(newtitle, 1) == "[") {
		if (StrLeft(newtitle, 7) == "[Buffer" ||
				StrLeft(newtitle, 4) == "[ICY") return;
	}
	strLastAutoTitle = newtitle;
	onNext();
}
onNext() {
	if (checkPref(0)) return;
	createNotifier();
	showNotifier(fillNextTrackInfo(""));
}
System.onPlay() {
	if (checkPref(0)) return;
	createNotifier();
	showNotifier(fillNextTrackInfo("Playing"));
}
System.onPause() {
	if (checkPref(0)) return;
	createNotifier();
	showNotifier(fillNextTrackInfo("Paused"));
}
System.onResume() {
	if (checkPref(0)) return;
	createNotifier();
	showNotifier(fillNextTrackInfo("Resuming"));
}
System.onStop() {
	if (checkPref(0)) return;
	createNotifier();
	showNotifier(fillNextTrackInfo("Stopped"));
}
Int checkPref(int bypassfs) {
	if (!bypassfs && attrib_notifierDisableFullscreen.getData() == "1" && isVideoFullscreen()) return 1;
	if (attrib_notifierNever.getData() == "1") return 1;
	if (attrib_notifierMinimized.getData() == "1" && !isMinimized()) return 1;
	return 0;
}
layoutNotifier.onTargetReached() {
	if (strPosition == "IN") {
		timerNotifier.setDelay(StringToInteger(attrib_notifierHoldtime.getData()));
		timerNotifier.start();
	} else if (strPosition == "OUT") {
		reset();	
	}
}
NotifierBG.onRightButtonDown(int x, int y) { timerNotifier.stop(); layoutNotifier.cancelTarget();	reset(); }
NotifierBG.onLeftButtonDown(int x, int y) { System.restoreApplication(); System.activateApplication(); }

reset() { containerNotifier.hide(); containerNotifier = NULL; layoutNotifier = NULL; }

createNotifier() {
	if (containerNotifier == NULL) {
		containerNotifier = newDynamicContainer("notifier");
		if (!containerNotifier) return;
		layoutNotifier = containerNotifier.getLayout("normal");
		if (!layoutNotifier) return;
		groupNotifierText = layoutNotifier.findObject("notifier.text");
		groupNotifierCover = layoutNotifier.findObject("notifier.cover");
		coverandbutton = layoutNotifier.findObject("coverandbutton");
		NotifierBG = layoutNotifier.findObject("notifier.bg");
		coverBorder = layoutNotifier.findObject("cover.border");
		layerNotifierCoverImage = layoutNotifier.findObject("cover.image.n");
		NotifierWidth = layoutNotifier.getWidth() + 20;
		if (attrib_notifierAOT.getData() == "0") { layoutNotifier.setXMLParam("ontop", "0"); } else { if (attrib_notifierAOT.getData() == "1") { layoutNotifier.setXMLParam("ontop", "1");	} }
	} else { layoutNotifier.cancelTarget(); timerNotifier.stop(); }
}
showNotifier(int w) {
	int intW = w + 100;
	int intH = 141;
	int intRightOnScreenX = getViewportWidth() + getViewportLeft() - intW - intScreenMargin;
	int intRightOffScreenX = getViewportWidth() + getViewportLeft();
	int intLeftOnScreenX = intScreenMargin + getViewportLeft();
	int intLeftOffScreenX = (intW * -1) + getViewportLeft();
	int intTopOnScreenY = getViewportTop() + intScreenMargin;
	int intTopOffScreenY = (intH * -1) + getViewportTop() - 25;
	int intBottomOnScreenY = getViewportHeight() + getViewportTop() - intH - intScreenMargin;
	int intBottomOffScreenY = getViewportHeight() + getViewportTop() + 25;
	int intSelectedStartX;
	int intSelectedStartY;
	int intSelectedFinalX;
	int intSelectedFinalY;
	if (attrib_notifierFade.getData() == "1" || attrib_notifierNoAnimation.getData() == "1" || attrib_notifierRollUpDown.getData() == "1") {
		if (attrib_notifierPositionRight.getData() == "1") {
			if (attrib_notifierPositionBottom.getData() == "1") {
				intSelectedStartX = intRightOnScreenX;
				intSelectedFinalX = intRightOnScreenX;
				intSelectedStartY = intBottomOnScreenY;
				intSelectedFinalY = intBottomOnScreenY;
			} else {
				intSelectedStartX = intRightOnScreenX;
				intSelectedFinalX = intRightOnScreenX;
				intSelectedStartY = intTopOnScreenY;
				intSelectedFinalY = intTopOnScreenY;
			}
		} else {
			if (attrib_notifierPositionBottom.getData() == "1") {
				intSelectedStartX = intLeftOnScreenX;
				intSelectedFinalX = intLeftOnScreenX;
				intSelectedStartY = intBottomOnScreenY;
				intSelectedFinalY = intBottomOnScreenY;
			} else {
				intSelectedStartX = intLeftOnScreenX;
				intSelectedFinalX = intLeftOnScreenX;
				intSelectedStartY = intTopOnScreenY;
				intSelectedFinalY = intTopOnScreenY;
			}
		}
	} else {
		if (attrib_notifierPositionRight.getData() == "1") {
			if (attrib_notifierSlideVertical.getData() == "1") {
				if (attrib_notifierPositionBottom.getData() == "1") {
					intSelectedStartX = intRightOnScreenX;
					intSelectedFinalX = intRightOnScreenX;
					intSelectedStartY = intBottomOffScreenY;
					intSelectedFinalY = intBottomOnScreenY;
				} else {
					intSelectedStartX = intRightOnScreenX;
					intSelectedFinalX = intRightOnScreenX;
					intSelectedStartY = intTopOffScreenY;
					intSelectedFinalY = intTopOnScreenY;
				}
			} else {
				if (attrib_notifierPositionBottom.getData() == "1") {
					intSelectedStartX = intRightOffScreenX;
					intSelectedFinalX = intRightOnScreenX;
					intSelectedStartY = intBottomOnScreenY;
					intSelectedFinalY = intBottomOnScreenY;
				} else {
					intSelectedStartX = intRightOffScreenX;
					intSelectedFinalX = intRightOnScreenX;
					intSelectedStartY = intTopOnScreenY;
					intSelectedFinalY = intTopOnScreenY;
				}
			}
		} else {
			if (attrib_notifierSlideVertical.getData() == "1") {
				if (attrib_notifierPositionBottom.getData() == "1") {
					intSelectedStartX = intLeftOnScreenX;
					intSelectedFinalX = intLeftOnScreenX;
					intSelectedStartY = intBottomOffScreenY;
					intSelectedFinalY = intBottomOnScreenY;
				} else {
					intSelectedStartX = intLeftOnScreenX;
					intSelectedFinalX = intLeftOnScreenX;
					intSelectedStartY = intTopOffScreenY;
					intSelectedFinalY = intTopOnScreenY;
				}
			} else {
				if (attrib_notifierPositionBottom.getData() == "1") {
					intSelectedStartX = intLeftOffScreenX;
					intSelectedFinalX = intLeftOnScreenX;
					intSelectedStartY = intBottomOnScreenY;
					intSelectedFinalY = intBottomOnScreenY;
				} else {
					intSelectedStartX = intLeftOffScreenX;
					intSelectedFinalX = intLeftOnScreenX;
					intSelectedStartY = intTopOnScreenY;
					intSelectedFinalY = intTopOnScreenY;
				}
			}
		}
	}
	if (NotifierTop != NULL) {
		if (attrib_notifierSlideVertical.getData() == "1") {
			intSelectedStartY = intBottomOffScreenY;
			intSelectedFinalY = NotifierTop;
		} else {
			intSelectedStartY = NotifierTop;
			intSelectedFinalY = NotifierTop;
		}
	}
	if (layoutNotifier.isVisible()) {
		layoutNotifier.resize(intSelectedFinalX, intSelectedFinalY, intW, intH);
		layoutNotifier.setAlpha(255);
		coverandbutton.cancelTarget(); 
		coverandbutton.resize(0,0,85,92);
	} else {
		if (attrib_notifierRollUpDown.getData() != "1") {
			layoutNotifier.resize(intSelectedStartX, intSelectedStartY, intW, intH);
		} else {
			layoutNotifier.resize(intSelectedStartX, intSelectedStartY, intW, 0);
			coverandbutton.setXMLParam("h", "0");
			}
		if (attrib_notifierFade.getData() == "1") layoutNotifier.setAlpha(0);
	}
	if (attrib_notifierFade.getData() != "1") layoutNotifier.setAlpha(255);
	layoutNotifier.show();
	layoutNotifier.setTargetA(255);
	layoutNotifier.setTargetX(intSelectedFinalX);
	layoutNotifier.setTargetY(intSelectedFinalY);
	layoutNotifier.setTargetW(intW);
	layoutNotifier.setTargetH(intH);
	if (attrib_notifierNoAnimation.getData() == "1") {
		layoutNotifier.setTargetSpeed(0);
	} else {
		layoutNotifier.setTargetSpeed(StringToInteger(attrib_notifierSlideTime.getData()));
	}		
	coverandbutton.setTargetH(92);
	coverandbutton.setTargetSpeed(StringToFloat(attrib_notifierSlideTime.getData()) + 0.3);
	layoutNotifier.gotoTarget();
	coverandbutton.gotoTarget();
	strPosition = "IN";
}
layoutNotifier.onEndMove() {
	NotifierTop = layoutNotifier.getTop();
}	
timerNotifier.onTimer() {
	stop();
	if (System.StringtoInteger(attrib_notifierHoldtime.getData()) < 21000) {
		int intW = w;
		int intH = layoutNotifier.getHeight();
		int intRightOnScreenX = getViewportWidth() + getViewportLeft() - intW - intScreenMargin;
		int intRightOffScreenX = getViewportWidth() + getViewportLeft();
		int intLeftOnScreenX = intScreenMargin + getViewportLeft();
		int intLeftOffScreenX = (intW * -1) + getViewportLeft();
		int intTopOnScreenY = getViewportTop() + intScreenMargin;
		int intTopOffScreenY = (intH * -1) + getViewportTop() - 25;
		int intBottomOnScreenY = getViewportHeight() + getViewportTop() - intH - intScreenMargin;
		int intBottomOffScreenY = getViewportHeight() + getViewportTop() + 25;
		int intSelectedFinalX;
		int intSelectedFinalY;	
		if (attrib_notifierFade.getData() == "1") {
			layoutNotifier.setTargetY(layoutNotifier.getTop());
			layoutNotifier.setTargetX(layoutNotifier.getLeft());
			layoutNotifier.setTargetA(0);
			layoutNotifier.setTargetSpeed(StringToInteger(attrib_notifierSlideTime.getData()));
			layoutNotifier.gotoTarget();
		} else if (attrib_notifierNoAnimation.getData() == "1") {
			layoutNotifier.setTargetY(layoutNotifier.getTop());
			layoutNotifier.setTargetX(layoutNotifier.getLeft());
			layoutNotifier.setTargetA(0);
			layoutNotifier.setTargetSpeed(0);
			layoutNotifier.gotoTarget();
		} else if (attrib_notifierRollUpDown.getData() == "1") {
			layoutNotifier.setTargetY(layoutNotifier.getTop());
			layoutNotifier.setTargetX(layoutNotifier.getLeft());
			coverandbutton.setTargetH(0);
			coverandbutton.setTargetSpeed(StringToFloat(attrib_notifierSlideTime.getData()) - 0.2);
			coverandbutton.gotoTarget();
			layoutNotifier.setTargetH(0);
			layoutNotifier.setTargetSpeed(StringToInteger(attrib_notifierSlideTime.getData()));
			layoutNotifier.gotoTarget();
		} else {
			if (attrib_notifierPositionRight.getData() == "1") {
				if (attrib_notifierSlideVertical.getData() == "1") {
					if (attrib_notifierPositionBottom.getData() == "1") {
						intSelectedFinalX = layoutNotifier.getLeft();
						intSelectedFinalY = intBottomOffScreenY;
					} else {
						intSelectedFinalX = layoutNotifier.getLeft();
						intSelectedFinalY = intTopOffScreenY;
					}
				} else {
					if (attrib_notifierPositionBottom.getData() == "1") {
						intSelectedFinalX = intRightOffScreenX;
						if (NotifierTop == NULL) {
							intSelectedFinalY = intBottomOnScreenY;
						} else {
							intSelectedFinalY = NotifierTop;
						}	
					} else {
						intSelectedFinalX = intRightOffScreenX;
						intSelectedFinalY = NotifierTop;
					}
				}
			} else {
				if (attrib_notifierSlideVertical.getData() == "1") {
					if (attrib_notifierPositionBottom.getData() == "1") {
						intSelectedFinalX = intLeftOnScreenX;
						intSelectedFinalY = intBottomOffScreenY;
					} else {
						intSelectedFinalX = intLeftOnScreenX;
						intSelectedFinalY = intTopOffScreenY;
					}
				} else {
					if (attrib_notifierPositionBottom.getData() == "1") {
						intSelectedFinalX = (NotifierWidth * -1) + getViewportLeft();
						if (NotifierTop == NULL) {
							intSelectedFinalY = intBottomOnScreenY;
						} else {
							intSelectedFinalY = NotifierTop;
						}
					} else {
						intSelectedFinalX = (NotifierWidth * -1) + getViewportLeft();
						intSelectedFinalY = NotifierTop;
					}
				}
			}
			layoutNotifier.setTargetX(intSelectedFinalX);
			layoutNotifier.setTargetY(intSelectedFinalY);
			layoutNotifier.setTargetSpeed(StringToInteger(attrib_notifierSlideTime.getData()));
			layoutNotifier.gotoTarget();
		}
		strPosition = "OUT";
	}
}
Int fillNextTrackInfo(String corneroverride) {
	Int maxv = 0; Int stream = 0; Group p = layoutNotifier; Text plentry = p.findObject("plentry"); Text nexttrack = p.findObject("nexttrack"); Text _title = p.findObject("title"); Text album = p.findObject("album"); Text artist = p.findObject("artist"); if (StrLeft(getPlayItemString(), 7) == "http://") stream = 1; if (plentry) { plentry.setText(integerToString(getPlaylistIndex()+1)+"/"+integerToString(getPlaylistLength())); plentry.show(); } if (nexttrack) { if (corneroverride == "") { if (!stream) { if (!isVideo()) nexttrack.setText("New Track"); else nexttrack.setText("New Video"); } else nexttrack.setText("On Air"); } else nexttrack.setText(corneroverride);	nexttrack.show(); }
	if (_title) { String str; if (!stream) { _title.setXmlParam("ticker", "0"); _title.setXmlParam("display", ""); str = getPlayitemMetaDataString("title"); if (str == "") str = getPlayitemDisplayTitle(); String l = getPlayItemMetaDataString("length"); if (l != "") { str += " (" + integerToTime(stringtointeger(l)) + ")"; }	_title.setText(str); } else {	_title.setXmlParam("ticker", "1"); _title.setXmlParam("display", "songtitle");	_title.setText("");	} _title.show(); }
	if (artist) { if (!stream) { if (isVideo()) artist.setText(""); else	artist.setText(getPlayitemMetaDataString("artist")); } else { if (isVideo())	artist.setText("Internet TV"); else artist.setText("Internet Radio"); } artist.show(); }
	if (album) { String str; if (!stream && !isVideo()) { album.setXmlParam("display", ""); str = getPlayitemMetaDataString("album"); String l = getPlayitemMetaDataString("track"); if (l != "" && l != "-1") str += " (Track " + l + ")"; album.setText(str); } else { album.setText(""); album.setXmlParam("display", "songinfo"); } album.show(); }
	
	Boolean boolNotifierCoverImageFound = false;
	if (layerNotifierCoverImage != NULL) {
		if (attrib_notifierShowCoverArt.getData() == "1") {
			boolNotifierCoverImageFound = (getCoverFilePath() != "");
		}
		if (boolNotifierCoverImageFound && attrib_notifierShowCoverArt.getData() == "1") {
			groupNotifierCover.show();
			coverBorder.show();
			groupNotifierText.setTargetX(78);
			groupNotifierText.setTargetW(-84);
			groupNotifierText.setTargetSpeed(0);
			groupNotifierText.gotoTarget();
		} else {
			if (attrib_notifierShowCoverArt.getData() != "1") groupNotifierCover.hide();
			coverBorder.hide();
			groupNotifierText.setTargetX(15);
			groupNotifierText.setTargetW(-24);
			groupNotifierText.setTargetSpeed(0);
			groupNotifierText.gotoTarget();
		}
	}
	maxv = artist.getAutoWidth();
	if (maxv < album.getAutoWidth()) maxv = album.getAutoWidth();
	if (maxv < _title.getAutoWidth()) maxv = _title.getAutoWidth();
	if (boolNotifierCoverImageFound && attrib_notifierShowCoverArt.getData() == "1") { maxv = maxv + groupNotifierCover.getWidth(); if (maxv < 180) maxv = 180; }
	if (maxv > getViewportWidth()/1) maxv = getViewportWidth()/1;
	return maxv;
}

attrib_notifierAOT.onDataChanged() { if (attrib_notifierAOT.getData() == "0") { createNotifier(); layoutNotifier.setXMLParam("ontop", "0"); } else { if (attrib_notifierAOT.getData() == "1") { createNotifier();	layoutNotifier.setXMLParam("ontop", "1"); } } if (strPosition == "IN") { timerNotifier.setDelay(StringToInteger(attrib_notifierHoldtime.getData()));	timerNotifier.start();	} else if (strPosition == "OUT") { reset(); } }

attrib_notifierHoldtime.onDataChanged() {
	createNotifier();
	Int intNotifierHoldtime = System.StringtoInteger(attrib_notifierHoldtime.getData());
	intNotifierHoldtime = sliderHoldtime.getPosition();
	if (intNotifierHoldtime >= 21000) {
		textHoldtime.setAlpha(0);
		textHoldtimeSec.setText("Forever");
		timerNotifier.stop();
		layoutNotifier.cancelTarget();
	} else {
		textHoldtime.setAlpha(255);
		textHoldtime.setText(System.IntegertoString(intNotifierHoldtime / 1000));
		textHoldtimeSec.setText("Sec");
		layoutNotifier.gotoTarget();
	}	
}
attrib_notifierSlideTime.onDataChanged() {
	createNotifier();
	Int intNotifierSlidetime = System.stringToInteger(attrib_notifierSlideTime.getData());
	intNotifierSlidetime = sliderSlidetime.getPosition();
	textSlidetime.setText(System.integerToString(intNotifierSlideTime));
	if (intNotifierHoldtime < 20000) layoutNotifier.gotoTarget();
}

attrib_notifierAlways.onDataChanged() { timerShow.setDelay(100); timerShow.start(); }
attrib_notifierNever.onDataChanged() { createNotifier(); timerNotifier.stop(); layoutNotifier.cancelTarget(); reset(); }

timerShow.onTimer() { System.onShowNotification(); timerShow.stop(); }