//original idea from T3C by rpeterclark
#include "../../../lib/std.mi"

Function syncStandardFrame();
Function syncDLClear();
Function setNewGroup(String strGroupID);

Global Container containerDLClear;
Global Layout layoutStandardFrame, layoutDLClear;
Global Group groupStandardFrame, groupStandardFrameContent;
Global GuiObject gripTop, topmiddle;
Global String strParamX, strParamY, strParamW, strParamH, strParamRX, strParamRY, strParamRW, strParamRH;
Global Timer timerSyncSettings;

System.onScriptLoaded() {
	containerDLClear = newDynamicContainer("cont.clear.DL");
	layoutDLClear = containerDLClear.getLayout("layout.clear.DL");
	groupStandardFrame = getScriptGroup();	
	layoutStandardFrame = groupStandardFrame.getParentLayout();	
	gripTop = layoutDLClear.findObject("grip.top.mover");
	topmiddle = layoutStandardFrame.findObject("top.middle");
	String strParam = System.getParam();
	strParamX = System.getToken(strParam, ",", 0);
	strParamY = System.getToken(strParam, ",", 1);
	strParamW = System.getToken(strParam, ",", 2);
	strParamH = System.getToken(strParam, ",", 3);
	strParamRX = System.getToken(strParam, ",", 4);
	strParamRY = System.getToken(strParam, ",", 5);
	strParamRW = System.getToken(strParam, ",", 6);
	strParamRH = System.getToken(strParam, ",", 7);	
	timerSyncSettings = new Timer;
	timerSyncSettings.setDelay(10);
	timerSyncSettings.start();		
}
System.onScriptUnloading() {
	timerSyncSettings.stop();
	delete timerSyncSettings;
}
timerSyncSettings.onTimer() {
	if (!layoutStandardFrame.isVisible()) {
		layoutDLClear.hide();
	} else {
		layoutDLClear.show();	
		syncDLClear();
	}
}
System.onSetXuiParam(String strParam, String strValue) {
	if (strParam == "content") {
		setNewGroup(strValue);
	}
}
layoutStandardFrame.onScale(Double newscalevalue) {
	layoutDLClear.setScale(newscalevalue);
}
layoutStandardFrame.onSetVisible(Boolean boolIsVisible) {
	if (boolIsVisible) {
		syncStandardFrame();
		layoutDLClear.show();
	} else {
		layoutDLClear.hide();		
	}
}
setNewGroup(String strGroupID) {
	groupStandardFrameContent = System.newGroup(strGroupID);
	if (groupStandardFrameContent == NULL) {
		messagebox("group \"" + strGroupID + "\" not found", "ButtonGroup", 0, "");
		return;
	}
	groupStandardFrameContent.setXMLParam("x", strParamX);
	groupStandardFrameContent.setXMLParam("y", strParamY);
	groupStandardFrameContent.setXMLParam("w", strParamW);
	groupStandardFrameContent.setXMLParam("h", strParamH);
	groupStandardFrameContent.setXMLParam("relatx", strParamRX);
	groupStandardFrameContent.setXMLParam("relaty", strParamRY);
	groupStandardFrameContent.setXMLParam("relatw", strParamRW);
	groupStandardFrameContent.setXMLParam("relath", strParamRH);
	groupStandardFrameContent.init(groupStandardFrame);
}
layoutDLClear.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncStandardFrame();
}
layoutDLClear.onMove() {
	syncStandardFrame();
}
syncStandardFrame() {
		layoutStandardFrame.resize(layoutDLClear.getLeft(), layoutDLClear.getTop(), layoutDLClear.getWidth(), layoutDLClear.getHeight());
		layoutStandardFrame.setFocus();
}
layoutStandardFrame.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncDLClear();
}
syncDLClear() {
		layoutDLClear.resize(layoutStandardFrame.getLeft(), layoutStandardFrame.getTop(), layoutStandardFrame.getWidth(), layoutStandardFrame.getHeight());
}
gripTop.onRightButtonDown(int x, int y) {
	layoutStandardFrame.hide();
}
topmiddle.onRightButtonDown(int x, int y) {
	layoutStandardFrame.hide();
}
topmiddle.onLeftButtonDown(int x, int y) {
	System.restoreApplication();
	System.activateApplication();
}	