//original idea from T3C by rpeterclark

#include "../../../lib/std.mi"

Function syncStandardFrame();
Function syncAVSClear();

Global Container containerAVSClear;
Global Layout layoutStandardFrame, layoutAVSClear;
Global group groupStandardFrame;
Global Timer timerSyncSettings;
Global GuiObject gripTop;

System.onScriptLoaded() {

	containerAVSClear = newDynamicContainer("cont.clear.avs");
	layoutAVSClear = containerAVSClear.getLayout("layout.clear.avs");
	groupStandardFrame = getScriptGroup();	
	layoutStandardFrame = groupStandardFrame.getParentLayout();	
        gripTop = layoutAVSClear.findObject("grip.top.mover");
	timerSyncSettings = new Timer;
	timerSyncSettings.setDelay(0);
	timerSyncSettings.start();	
}


System.onScriptUnloading() {
	timerSyncSettings.stop();
	delete timerSyncSettings;
}



timerSyncSettings.onTimer() {
	if (!layoutStandardFrame.isVisible()) {
		layoutAVSClear.hide();
	} else {
		layoutAVSClear.show();	
		syncAVSClear();
	}
}



layoutStandardFrame.onScale(Double newscalevalue) {
	layoutAVSClear.setScale(newscalevalue);
}

layoutStandardFrame.onSetVisible(Boolean boolIsVisible) {
	if (boolIsVisible) {
		syncStandardFrame();
		layoutAVSClear.show();
	} else {
		layoutAVSClear.hide();		
	}
}


layoutAVSClear.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncStandardFrame();
}


layoutStandardFrame.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncAVSClear();
}


layoutAVSClear.onMove() {
	syncStandardFrame();
}



syncStandardFrame() {
		layoutStandardFrame.resize(layoutAVSClear.getLeft(), layoutAVSClear.getTop(), layoutAVSClear.getWidth(), layoutAVSClear.getHeight());
}


syncAVSClear() {
	layoutAVSClear.resize(layoutStandardFrame.getLeft(), layoutStandardFrame.getTop(), layoutStandardFrame.getWidth(), layoutStandardFrame.getHeight());
}


gripTop.onRightButtonDown(int x, int y) {
	layoutStandardFrame.hide();

}