//original idea from T3C by rpeterclark
#include "../../../lib/std.mi"

Function syncStandardFrame();
Function syncMLClear();
Function Glow(GuiObject glow, Int FinalA);

Global Container containerMLClear, containerML;
Global Layout layoutStandardFrame, layoutMLClear, layoutML;
Global group groupStandardFrame;
Global GuiObject gripTop, topmiddle;
Global Layer SFMLmenuglow, ClearmenuMLglow;
Global Button SFMLmenu, ClearmenuML;
Global Timer timerSyncSettings;

System.onScriptLoaded() {
	containerMLClear = newDynamicContainer("cont.clear.ml");
	containerML = System.getContainer("MLibrary");
	layoutMLClear = containerMLClear.getLayout("layout.clear.ml");
	layoutML = containerML.getLayout("normal");
	groupStandardFrame = getScriptGroup();	
	gripTop = layoutMLClear.findObject("grip.top.mover");
	layoutStandardFrame = groupStandardFrame.getParentLayout();
	topmiddle = layoutML.findObject("top.middle");
	SFMLmenu = layoutStandardFrame.findObject("SFMLmenu");
	SFMLmenuglow = layoutStandardFrame.findObject("SFMLmenuglow");
	ClearmenuML = layoutMLClear.findObject("ClearmenuML");
	ClearmenuMLglow = layoutMLClear.findObject("ClearmenuMLglow");
	timerSyncSettings = new Timer;
	timerSyncSettings.setDelay(1);
	timerSyncSettings.start();	
}
System.onScriptUnloading() {
	timerSyncSettings.stop();
	delete timerSyncSettings;
}
timerSyncSettings.onTimer() {
	if (!layoutStandardFrame.isVisible()) {
		layoutMLClear.hide();
	} else {
		layoutMLClear.show();	
		syncMLClear();
	}
}
layoutStandardFrame.onScale(Double newscalevalue) {
	layoutMLClear.setScale(newscalevalue);
}
layoutStandardFrame.onSetVisible(Boolean boolIsVisible) {
	if (boolIsVisible) {
		syncStandardFrame();
	} else {
		layoutMLClear.hide();		
	}
}
layoutMLClear.onMove() {
	syncStandardFrame();
}
layoutMLClear.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncStandardFrame();
}
layoutStandardFrame.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncMLClear();
}
syncMLClear() {
	layoutMLClear.resize(layoutStandardFrame.getLeft(), layoutStandardFrame.getTop(), layoutStandardFrame.getWidth(), layoutStandardFrame.getHeight());
}
syncStandardFrame() {
		layoutStandardFrame.resize(layoutMLClear.getLeft(), layoutMLClear.getTop(), layoutMLClear.getWidth(), layoutMLClear.getHeight());
}
gripTop.onRightButtonDown(int x, int y) {
	layoutStandardFrame.hide();
}
ClearmenuML.onEnterArea() {
	ClearmenuML.setAlpha(255);
	Glow(ClearmenuMLglow, 255);
}
ClearmenuML.onLeaveArea() {
	ClearmenuML.setAlpha(0);
	Glow(ClearmenuMLglow, 0);
}
ClearmenuML.onLeftButtonDown(int x, int y) {
	SFMLmenu.leftclick();
	Glow(ClearmenuMLglow, 0);
}
topmiddle.onRightButtonDown(int x, int y) {
	layoutStandardFrame.hide();
}
topmiddle.onLeftButtonDown(int x, int y) {
	System.restoreApplication();
	System.activateApplication();
}	
SFMLmenu.onEnterArea() {
	Glow(SFMLmenuglow, 255);
}
SFMLmenu.onLeaveArea() {
	Glow(SFMLmenuglow, 0);
}
SFMLmenu.onLeftButtonDown(int x, int y) {
	Glow(SFMLmenuglow, 0);
}
Glow(GuiObject glow, Int FinalA) {
	glow.setTargetA(FinalA);
	glow.setTargetSpeed(0.25);
	glow.gotoTarget();
}