//original idea from T3C by rpeterclark
#include "../../../lib/std.mi"

Function syncStandardFrame();
Function syncPLClear();
Function Glow(GuiObject glow, Int FinalA);

Global Container containerPLClear, containerPLEdit;
Global Layout layoutStandardFrame, layoutPLClear, layoutPLEditShade, layoutPLEditNormal;
Global group groupStandardFrame;
Global GuiObject mousetrapclear, mousetrap;
Global Button PLSwitch, SFPLmenu, SFPLmenuSwitch, ClearmenuPL, ClearmenuPLSwitch;
Global Layer SFPLmenuglow, SFPLmenuSwitchglow, ClearmenuPLglow, ClearmenuPLSwitchglow;
Global Timer timerSyncSettings;
Global Int PLEditNormalHeight;

System.onScriptLoaded() {
	groupStandardFrame = getScriptGroup();	
	layoutStandardFrame = groupStandardFrame.getParentLayout();
	containerPLClear = newDynamicContainer("cont.clear.pl");
	containerPLEdit = System.getContainer("PLEdit");
	layoutPLClear = containerPLClear.getLayout("layout.clear.pl");
	layoutPLEditNormal = containerPLEdit.getLayout("normal");
	layoutPLEditShade = containerPLEdit.getLayout("shade");
	mousetrapclear = layoutPLClear.findObject("mousetrapclear");
	mousetrap = layoutPLEditNormal.findObject("top.middle.pl");
	PLSwitch = layoutStandardFrame.findObject("button.switch.pl");
	SFPLmenu = layoutStandardFrame.findObject("SFPLmenu");
	SFPLmenuglow = layoutStandardFrame.findObject("SFPLmenuglow");
	SFPLmenuSwitch = layoutStandardFrame.findObject("button.switch.pl");
	SFPLmenuSwitchglow = layoutStandardFrame.findObject("button.switch.plglow");
	ClearmenuPL = layoutPLClear.findObject("ClearmenuPL");
	ClearmenuPLSwitch = layoutPLClear.findObject("ClearmenuPLSwitch");
	ClearmenuPLglow = layoutPLClear.findObject("ClearmenuPLglow");
	ClearmenuPLSwitchglow = layoutPLClear.findObject("ClearmenuPLSwitchglow");
	timerSyncSettings = new Timer;
	timerSyncSettings.setDelay(10);
	timerSyncSettings.start();	
}
System.onScriptUnloading() {
	timerSyncSettings.stop();
	delete timerSyncSettings;
}
timerSyncSettings.onTimer() {
	if (layoutStandardFrame.isVisible()) {
		layoutPLClear.show();
		syncPLClear();		
	} else {
		layoutPLClear.hide();	
		timerSyncSettings.stop();
	}
}
layoutStandardFrame.onScale(Double newscalevalue) {
	layoutPLClear.setScale(newscalevalue);
}
layoutStandardFrame.onSetVisible(Boolean boolIsVisible) {
	if (boolIsVisible) {
		timerSyncSettings.start();
		syncPLClear();
	} else {
		layoutPLEditNormal.hide();
		layoutPLClear.hide();
		timerSyncSettings.stop();
	}
}
mousetrapclear.onLeftButtonDblClk(Int intX, Int intY) {
	containerPLEdit.switchToLayout("shade");
}
mousetrapclear.onRightButtonDown(int x, int y) {
  layoutStandardFrame.hide();
}
mousetrap.onLeftButtonDown(int x, int y) {
	System.restoreApplication();
	System.activateApplication();
}
mousetrap.onLeftButtonDblClk(int x, int y) {
	containerPLEdit.switchToLayout("shade");	
}
mousetrap.onRightButtonDown(int x, int y) {
  layoutStandardFrame.hide();
}
layoutPLClear.onMove() {
	syncStandardFrame();
}
layoutPLClear.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncStandardFrame();
}
layoutStandardFrame.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncPLClear();
}
syncStandardFrame() {
	layoutStandardFrame.resize(layoutPLClear.getLeft(), layoutPLClear.getTop(), layoutPLClear.getWidth(), layoutPLClear.getHeight());	
}
syncPLClear() {
	layoutPLClear.resize(layoutStandardFrame.getLeft(), layoutStandardFrame.getTop(), layoutStandardFrame.getWidth(), layoutStandardFrame.getHeight());
}
ClearmenuPL.onEnterArea() {
	ClearmenuPL.setAlpha(255);
	Glow(ClearmenuPLglow, 255);
}
ClearmenuPL.onLeaveArea() {
	ClearmenuPL.setAlpha(0);
	Glow(ClearmenuPLglow, 0);
}
ClearmenuPL.onLeftButtonDown(int x, int y) {
	Glow(ClearmenuPLglow, 0);
	SFPLmenu.leftclick();
}
ClearmenuPLSwitch.onEnterArea() {
	ClearmenuPLSwitch.setAlpha(255);
	Glow(ClearmenuPLSwitchglow, 255);
}
ClearmenuPLSwitch.onLeaveArea() {
	ClearmenuPLSwitch.setAlpha(0);
	Glow(ClearmenuPLSwitchglow, 0);
}
ClearmenuPLSwitch.onLeftButtonDown(int x, int y) {
	SFPLmenuSwitch.leftclick();
	Glow(ClearmenuPLSwitchglow, 0);
}
SFPLmenu.onEnterArea() {
	Glow(SFPLmenuglow, 255);
}
SFPLmenu.onLeaveArea() {
	Glow(SFPLmenuglow, 0);
}
SFPLmenu.onLeftButtonDown(int x, int y) {
	Glow(SFPLmenuglow, 0);
}
SFPLmenuSwitch.onEnterArea() {
	Glow(SFPLmenuSwitchglow, 255);
}
SFPLmenuSwitch.onLeaveArea() {
	Glow(SFPLmenuSwitchglow, 0);
}
SFPLmenuSwitch.onLeftButtonDown(int x, int y) {
	Glow(SFPLmenuSwitchglow, 0);
}
Glow(GuiObject glow, Int FinalA) {
	glow.setTargetA(FinalA);
	glow.setTargetSpeed(0.25);
	glow.gotoTarget();
}