//from T3C by rpeterclark

#include "../../../lib/std.mi"

Function syncClear();
Function Boolean clearIsSynced();

Global Layout layoutStandardFrame, layoutStandardFrameClear;
Global Group groupStandardFrame, groupStandardFrameContent;
Global Timer timerSyncSettings;
Global Boolean boolLayoutIsDragging;

System.onScriptLoaded() {
	groupStandardFrame = System.getScriptGroup();
	layoutStandardFrame = groupStandardFrame.getParentLayout();
	layoutStandardFrameClear = System.newGroupAsLayout("wasabi.frame.layout.clear");
	

	layoutStandardFrameClear.setXMLParam("x", "0");
	layoutStandardFrameClear.setXMLParam("y", "0");
	layoutStandardFrameClear.setXMLParam("w", "0");
	layoutStandardFrameClear.setXMLParam("h", "0");
	layoutStandardFrameClear.setXMLParam("relatw", "1");
	layoutStandardFrameClear.setXMLParam("relath", "1");
	layoutStandardFrameClear.setXMLParam("ghost", "1");
	layoutStandardFrameClear.setXMLParam("move", "0");
	layoutStandardFrameClear.setXMLParam("desktopalpha", "1");
	layoutStandardFrameClear.setXMLParam("noparent", "1");
	layoutStandardFrameClear.setXMLParam("nodock", "0");
	layoutStandardFrameClear.setXMLParam("noactivation", "1");

	boolLayoutIsDragging = false;
	
	timerSyncSettings = new Timer;
	timerSyncSettings.setDelay(0);
	timerSyncSettings.start();
}

System.onScriptUnloading() {
	timerSyncSettings.stop();
	delete timerSyncSettings;
}

	
timerSyncSettings.onTimer() {
	if (System.isAppActive() && layoutStandardFrame.isVisible() && !layoutStandardFrameClear.isVisible() && !boolLayoutIsDragging) {
		syncClear();
	}
}

layoutStandardFrame.onSetVisible(Boolean boolIsVisible) {
	if (boolIsVisible) {
		syncClear();
	} else {
		layoutStandardFrameClear.hide();
	}
}

layoutStandardFrame.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	if (layoutStandardFrame.isVisible()) {
		syncClear();
	}
}

syncClear() {
	layoutStandardFrameClear.resize(layoutStandardFrame.getLeft(), layoutStandardFrame.getTop(), layoutStandardFrame.getWidth(), layoutStandardFrame.getHeight());
	layoutStandardFrameClear.show();
}

Boolean clearIsSynced() {
	Boolean boolReturnValue = true;
	if (layoutStandardFrameClear.getLeft() != (layoutStandardFrame.getLeft())) { boolReturnValue = false; }
	if (layoutStandardFrameClear.getTop() != (layoutStandardFrame.getTop())) { boolReturnValue = false; }
	if (layoutStandardFrameClear.getWidth() != (layoutStandardFrame.getWidth())) { boolReturnValue = false; }
	if (layoutStandardFrameClear.getHeight() != (layoutStandardFrame.getHeight())) { boolReturnValue = false; }
	return boolReturnValue;
}