//original idea from T3C by rpeterclark
#include "../../../lib/std.mi"

Function syncStandardFrame();
Function syncVDClear();
Global Container containerVDClear;
Global Layout layoutStandardFrame, layoutVDClear;
Global group groupStandardFrame;
Global GuiObject gripTop, topmiddle;
Global Timer timerSyncSettingsVD;

System.onScriptLoaded() {
	containerVDClear = newDynamicContainer("cont.clear.vd");
	layoutVDClear = containerVDClear.getLayout("layout.clear.vd");
	groupStandardFrame = getScriptGroup();	
	layoutStandardFrame = groupStandardFrame.getParentLayout();
	gripTop = layoutVDClear.findObject("grip.top.mover");
	topmiddle = layoutStandardFrame.findObject("top.middle");
	timerSyncSettingsVD = new Timer;
	timerSyncSettingsVD.setDelay(100);
	timerSyncSettingsVD.start();		
}
System.onScriptUnloading() {
	timerSyncSettingsVD.stop();
	delete timerSyncSettingsVD;
}
timerSyncSettingsVD.onTimer() {
	if (!layoutStandardFrame.isVisible()) {
		layoutVDClear.hide();
	} else {
		layoutVDClear.show();	
		syncVDClear();
	}
}
layoutVDClear.onScale(Double newscalevalue) {
	layoutStandardFrame.setScale(newscalevalue);
}
layoutStandardFrame.onSetVisible(Boolean boolIsVisible) {
	if (boolIsVisible) {
		syncStandardFrame();
		layoutVDClear.show();
	} else {
		layoutVDClear.hide();		
	}
}
layoutStandardFrame.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncVDClear();
}
layoutVDClear.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	syncStandardFrame();
}
layoutVDClear.onMove() {
	syncStandardFrame();
}
syncStandardFrame() {
		layoutStandardFrame.resize(layoutVDClear.getLeft(), layoutVDClear.getTop(), layoutVDClear.getWidth(), layoutVDClear.getHeight());
}
syncVDClear() {
		layoutVDClear.resize(layoutStandardFrame.getLeft(), layoutStandardFrame.getTop(), layoutStandardFrame.getWidth(), layoutStandardFrame.getHeight());
}
gripTop.onRightButtonDown(int x, int y) {
	layoutStandardFrame.hide();
}
topmiddle.onRightButtonDown(int x, int y) {
	layoutStandardFrame.hide();
}